<template>
  <rui-form :errors="errors"
            model="family"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-alert variant="info">{{ $t('js.families.form.community_alert') }}</rui-alert>

    <rui-field input-id="family_name" :label="$t('activerecord.attributes.family.name')">
      <input id="family_name"
             v-model="inputs.name"
             type="text"
             name="name"
             autocomplete="off"
             required>
      <template #help>
        <div v-if="searchResults.length > 0">
          {{ $t('js.families.form.already_created') }}
          <rui-badge v-for="result in searchResults"
                     :key="result.id"
                     :caption="result.name"
                     variant="help"
                     size="small" />
        </div>
      </template>
    </rui-field>

    <rui-field input-id="family_kingdom" :label="$t('activerecord.attributes.family.kingdom')">
      <select id="family_kingdom" v-model="inputs.kingdom" name="kingdom" required>
        <option v-for="kingdom in kingdoms" :key="kingdom" :value="kingdom">{{ $t(`activerecord.attributes.family/kingdom.${kingdom}`) }}</option>
      </select>
    </rui-field>

    <rui-field input-id="family_source" :label="$t('activerecord.attributes.family.source')" :help="$t('js.families.form.source_help')">
      <input id="family_source" v-model="inputs.source" type="url" name="source">
    </rui-field>
  </rui-form>
</template>
<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import { FAMILY_KINGDOMS } from '../../../../../helpers/constants.js'
import Family from '../../../../classes/models/Family'
import Toaster from '../../../../tools/Toaster'

export default {
  name: 'GpaFamilyForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiBadge, RuiField, RuiAlert, RuiForm },
  props: {
    family: { required: false, type: Family, default: null },
  },
  data () {
    return {
      inputs: { ...this.fillInputs() },
      errors: null,
      loading: false,
      kingdoms: FAMILY_KINGDOMS,
    }
  },
  computed: {
    searchResults () { return this.$store.getters.familySearch(this.inputs.name) },
  },
  methods: {
    fillInputs () {
      return {
        id: null,
        name: '',
        description: '',
        source: '',
        kingdom: '',
        ...this.$props.family,
      }
    },
    save () {
      const payload = { ...this.inputs }
      if (!payload.id) { delete payload.id }

      this.loading = true
      this.errors = null
      this.$store.dispatch('saveFamily', payload)
        .then(() => {
          Toaster.success(this.$t('js.generic.successfully_saved'))
          this.$emit('saved')
        })
        .catch((errors) => {
          Toaster.error(this.$t('js.generic.failed_to_save'))
          this.errors = errors
        })
        .then(() => { this.loading = false })
    },
  },
  watch: {
    family () {
      this.inputs = this.fillInputs()
    },
  },
}
</script>
